import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class BoutonFarceur extends JFrame {
    JPanel jeuPanel; 
    JButton bouton;
    int centreBoutonX;
    int centreBoutonY;
    int nbFois = 0;
    
    public BoutonFarceur() {
        super("Cliquez sur le bouton !");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        jeuPanel = new JPanel();
        bouton = new JButton("Attrape moi");
        Container c = getContentPane();
        c.add(jeuPanel, BorderLayout.CENTER);
        jeuPanel.setLayout(new FlowLayout());
        jeuPanel.add(bouton);
        setSize(400,400);
        setVisible(true);
        jeuPanel.addMouseMotionListener(new DeplaceBouton());
        bouton.addActionListener(new BoutonAttrape());
    }
    
    void placeBouton()
    {
        int echelleSurX = jeuPanel.getWidth() - bouton.getWidth();
        int echelleSurY = jeuPanel.getHeight() - bouton.getHeight();
        int x = (int) (Math.random() * echelleSurX);
        int y = (int) (Math.random() * echelleSurY);
        bouton.setLocation(x,y);
        }
    
    class DeplaceBouton extends MouseMotionAdapter
    {
        public void mouseMoved(MouseEvent e)
        {
            /* C'est suffisant
            placeBouton(); */
            /* On amliore en faisant fuir le bouton au dernier moment */
            int deltaX = Math.abs(bouton.getX() + bouton.getWidth()/2  - e.getX());
            int deltaY = Math.abs(bouton.getY() + bouton.getHeight()/2 - e.getY());
            if (deltaX <= bouton.getWidth() * 1.5 && deltaY <= bouton.getHeight() * 1.5)
                placeBouton();
        }
    }

    class BoutonAttrape implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
            bouton.setText("Cliqu " + (++nbFois) + " fois");
            placeBouton();
        }
    }
    
    public static void main(String[] args) {
        BoutonFarceur farce = new BoutonFarceur();
        farce.placeBouton();
    }
}
